#ifndef __Tag_h__
#define __Tag_h__

#include "ZString.h"
#include "MString.h"
#include "Global.h"
#include <map>

namespace jet {

   class Tag : public coreutils::ZString {

    public:
      Tag(coreutils::ZString &in, coreutils::MString &parentOut, Global &global, Tag *parent = NULL, Tag *local = NULL, coreutils::ZString splitTagName = "");
      virtual ~Tag();

      void resolveKeyword(coreutils::ZString keyword);
      std::map<coreutils::MString, coreutils::MString> variables;
      std::map<coreutils::MString, coreutils::MString> keywords;
      coreutils::ZString name;
      coreutils::ZString container;
      coreutils::ZString container2;
      Tag *parent;
      Tag *local;

    protected:
      bool hasContainer = false;
      bool hasContainer2 = false;
      bool keywordDefined(coreutils::ZString variable);
      void parseContainer(coreutils::ZString &in, coreutils::MString &out);
      void processContainer(coreutils::ZString &container);
      void copyContainer(coreutils::ZString &in, coreutils::MString &out);

      Global &global;

      coreutils::MString &parentOut;
      coreutils::MString out;
      coreutils::MString containerOut;

      bool output = true;
      bool evaluate = true;
      bool filterBlankLines = false;
      bool trimLines = false;
      bool cleanWhitespace = false;

    private:
      bool containerOnly = false;
      coreutils::ZString splitTagName;

      int skipBlankLine(coreutils::ZString in);

      void scanContainer(coreutils::ZString &in);
      bool ifNested(coreutils::ZString &in);
      bool ifTagName(coreutils::ZString &in, const char *tag);
      bool ifTagName(coreutils::ZString &in);
      bool ifTagDefined(coreutils::ZString &in, coreutils::ZString &tag);
      bool ifEndTagName(coreutils::ZString &in);
      bool ifSplitTagName(coreutils::ZString &in);

   };

}

#endif
