#include "__header.h"
#include "Exception.h"
#include "Operand.h"
#include <iostream>

namespace jet {
   
   __header::__header(coreutils::ZString &in, coreutils::MString &parentOut, Global &global, Tag *parent, Tag *local) : Tag(in, parentOut, global, parent, local) {
      output = false;
      if(!keywordDefined("name"))
	throw coreutils::Exception("header tag must have name defined.");
      if(!keywordDefined("expr") && keywordDefined("value") && hasContainer)
	throw coreutils::Exception("header tag cannot have both value and a container.");
      if(keywordDefined("expr") && !keywordDefined("value") && hasContainer)
	throw coreutils::Exception("header tag cannot have both expr and a container.");
      if(keywordDefined("expr") && keywordDefined("value") && !hasContainer)
	throw coreutils::Exception("header tag cannot have both expr and value.");
      if(!keywordDefined("expr") && !keywordDefined("value") && !hasContainer)
	throw coreutils::Exception("header tag must have a value, expr or a container.");
      resolveKeyword("name");
      if(keywordDefined("expr")) {
	 if(keywordDefined("eval"))
	   throw coreutils::Exception("Cannot use eval with expr.");	 
	 global.headers[keywords["name"]] = Operand(keywords["expr"], global, parent->variables, keywords).string;	    
      } else if(hasContainer) {
	 processContainer(container);
	 if(evaluate) {
	    global.headers[keywords["name"]] = out;	       
	 } else {	   
	    global.headers[keywords["name"]] = container;
	 }	    
      } else {
	 resolveKeyword("value");
	 global.headers[keywords["name"]] = keywords["value"];
      }      
   }      
}
